/*****************************************************************************/
/* general.c : Fonction gnrales
 * general.c : Generals functions
 *
 *
 * hOpla : Lien XML-SQL - XML-SQL link
 * Copyright (c) 2000 Philippe Roy
 * Auteur - Author : Philippe Roy
 *
 *
 * Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
 * sous les termes de la licence publique gnrale GNU telle qu'elle est publie par
 * la Free Software Foundation ; soit la version 2 de la licence, ou
 * (comme vous voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir qu'il sera utile,
 * mais SANS AUCUNE GARANTIE ; mme sans la garantie de
 * COMMERCIALIT ou d'ADQUATION A UN BUT PARTICULIER. Voir la
 * licence publique gnrale GNU pour plus de dtails.
 *
 * Vous devriez avoir reu une copie de la licence publique gnrale GNU
 * avec ce programme ; si ce n'est pas le cas, crivez  la Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/*****************************************************************************/
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <dlfcn.h>

#include "hopla.h"


/*****************************************************************************/
/* Message */
/*****************************************************************************/
void hopla_message (gchar *message, gchar *type)
{

  /* Console */
  if ((type)&&(!HOPLA_NOCOLOR_MODE_POPT))
    {
      if (!strcmp (type, "done"))
	printf("%s%s : %s%s\n", "\033[32m\033[1m", message, _("done"),"\033[0m");
      if (!strcmp (type, "failed"))
	printf("%s%s : %s%s\n", "\033[31m\033[1m", message, _("failed"),"\033[0m");
      if (!strcmp (type, "tested"))
	printf("%s%s : %s%s\n", "\033[33m\033[1m", message, _("tested"),"\033[0m");
      if (!strcmp (type, "begin"))
	printf("%s : %s\n", message, _("begin"));
      if (!strcmp (type, "end"))
	printf("%s : %s\n", message, _("end"));
      if (!strcmp (type, "stop"))
	printf("%s%s : %s%s\n", "\033[31m\033[1m", message, _("stop"),"\033[0m");
      if (!strcmp (type, "yes"))
	printf("%s%s : %s%s\n", "\033[36m\033[1m", message, _("yes"),"\033[0m");
      if (!strcmp (type, "no"))
	printf("%s%s : %s%s\n", "\033[34m\033[1m", message, _("no"),"\033[0m");
      if (!strcmp (type, "plugins"))
	printf("%s : %s\n", message, _("plugins"));
      if (!strcmp (type, "command"))
	printf("%s : %s\n", message, _("command"));
    }
  if ((type)&&(HOPLA_NOCOLOR_MODE_POPT))
    {
      if (!strcmp (type, "done"))
	printf("%s : %s\n", message, _("done"));
      if (!strcmp (type, "failed"))
	printf("%s : %s\n", message, _("failed"));
      if (!strcmp (type, "tested"))
	printf("%s : %s\n", message, _("tested"));
      if (!strcmp (type, "begin"))
	printf("%s : %s\n", message, _("begin"));
      if (!strcmp (type, "end"))
	printf("%s : %s\n", message, _("end"));
      if (!strcmp (type, "stop"))
	printf("%s : %s\n", message, _("stop"));
      if (!strcmp (type, "yes"))
	printf("%s : %s\n", message, _("yes"));
      if (!strcmp (type, "no"))
	printf("%s : %s\n", message, _("no"));
      if (!strcmp (type, "plugins"))
	printf("%s : %s\n", message, _("plugins"));
      if (!strcmp (type, "command"))
	printf("%s : %s\n", message, _("command"));
    }
  if (!type)
    printf("%s\n", message);

  /* XML */
  if ((type) && (HOPLA_XMLLOG_FILE_POPT))
    {
      HOPLA_XMLLOG_ITEM = xmlNewChild (HOPLA_XMLLOG_TREE, HOPLA_XMLLOG_NS, "message", NULL);
      xmlSetProp (HOPLA_XMLLOG_ITEM, "text", message);
      xmlSetProp (HOPLA_XMLLOG_ITEM, "type", type);
      xmlSetProp (HOPLA_XMLLOG_ITEM, "level", g_strdup_printf("%d", HOPLA_XMLLOG_LEVEL));
      if (!strcmp (type, "begin"))
	HOPLA_XMLLOG_LEVEL = HOPLA_XMLLOG_LEVEL++;
      if (!strcmp (type, "end"))
	HOPLA_XMLLOG_LEVEL = HOPLA_XMLLOG_LEVEL--;
    }
  
  /* Bouton d'arrt d'urgence - Big red button */
  if (type)
    if (!strcmp (type, "stop"))
      gtk_exit (1);
}

gboolean hopla_open_xmllog (void)
{
  FILE *fp2;

  /* Vrif de faisabilit */
  fp2 = fopen (HOPLA_XMLLOG_FILE_POPT, "w");
  if (!fp2)
    {
      hopla_message (_("Opening log file"), "failed");
      return FALSE;
    }
  fclose (fp2);

  /* Go ! */
  HOPLA_XMLLOG_DOC = xmlNewDoc ("1.0");
  HOPLA_XMLLOG_NS = xmlNewGlobalNs (HOPLA_XMLLOG_DOC, "hopla-log/1.0.1","hOpla-log" );
  HOPLA_XMLLOG_DOC->root = xmlNewDocNode (HOPLA_XMLLOG_DOC, HOPLA_XMLLOG_NS, "messages", NULL);
  HOPLA_XMLLOG_TREE = HOPLA_XMLLOG_DOC->root;
  HOPLA_XMLLOG_LEVEL = 0;
  return TRUE;
}

gboolean hopla_close_xmllog (void)
{
  /* Go ! */
  if (xmlSaveFile (HOPLA_XMLLOG_FILE_POPT, HOPLA_XMLLOG_DOC) < 0)
    {
      hopla_message (_("Writting log file"), "failed");
      xmlFreeDoc (HOPLA_XMLLOG_DOC);
      return FALSE;
    }
  xmlFreeDoc (HOPLA_XMLLOG_DOC);

  /* Arbre de log cohrent ? */
  if (HOPLA_XMLLOG_LEVEL !=0)
    printf (_("Very strange, XML Log isn't coherent file '%s' : last level = '%d'\n"), HOPLA_XMLLOG_FILE_POPT, HOPLA_XMLLOG_LEVEL);
  return TRUE;
}

/*****************************************************************************/
/* Greffons */
/*****************************************************************************/
gboolean hopla_verif_plugins (gchar *file, gchar *function)
{
  void *greffon_tampon;
  void (*greffon_tampon2)();

  /* Fichier */
  greffon_tampon = dlopen (file, RTLD_LAZY);
  if (dlerror() !=NULL)
    {
      hopla_message (g_strdup_printf (_("Loading plug-in : file '%s' unreadable"), file), "failed");
      return FALSE;
    }

  /* Fonction */
  greffon_tampon2 = dlsym (greffon_tampon, function);
  if (dlerror() !=NULL)
    {
      hopla_message (g_strdup_printf (_("Loading plug-in : file '%s' : function '%s' not find"), file, function), "failed");
      return FALSE;
    }
  hopla_message (g_strdup_printf (_("Loading plug-in : file '%s' : function '%s'"), file, function), "plugins");
  return TRUE;
}
