/*****************************************************************************/
/* hopla.h : Types standards et fonctions standards
 * hopla.h : Usuals types and usuals functions
 *
 *
 * hOpla : Lien XML-SQL - XML-SQL link
 * Copyright (c) 2000 Philippe Roy
 * Auteur - Author : Philippe Roy
 *
 *
 * Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
 * sous les termes de la licence publique gnrale GNU telle qu'elle est publie par
 * la Free Software Foundation ; soit la version 2 de la licence, ou
 * (comme vous voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir qu'il sera utile,
 * mais SANS AUCUNE GARANTIE ; mme sans la garantie de
 * COMMERCIALIT ou d'ADQUATION A UN BUT PARTICULIER. Voir la
 * licence publique gnrale GNU pour plus de dtails.
 *
 * Vous devriez avoir reu une copie de la licence publique gnrale GNU
 * avec ce programme ; si ce n'est pas le cas, crivez  la Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/*****************************************************************************/

#include <parser.h>
#include <tree.h>


/*****************************************************************************/
/* Types base */
/* copie de chez ToutDoux */
/*****************************************************************************/
/* Champs table */
typedef struct Td_xmlfield_tmp
{
  xmlChar *name;
  xmlChar *comment;
  int key;
  xmlChar *type;
  xmlChar *type_comment;
} Td_xmlfield_tmp, *Td_xmlfield;

/* Table */
typedef struct Td_xmltable_tmp
{
  xmlChar *name;
  xmlChar *comment;
  int nbfields;
  Td_xmlfield fields[50];
} Td_xmltable_tmp, *Td_xmltable;

/* Champs vue */
typedef struct Td_xmlviewfield_tmp
{
  xmlChar *name;
  xmlChar *plugins;
  int nbproperties;
  xmlChar *properties[50];
  xmlChar *properties_value[50];
} Td_xmlviewfield_tmp, *Td_xmlviewfield;

/* Vue */
typedef struct Td_xmlview_tmp
{
  xmlChar *name;
  xmlChar *plugins;
  int nbfields;
  Td_xmlviewfield fields[50];
} Td_xmlview_tmp, *Td_xmlview;

/* Table de donnes */
typedef struct Td_xmldatatable_tmp
{
  xmlChar *table_source;
  int nbfields;
  xmlChar *fields[50]; /* for compatibility */
  xmlChar *types[50]; /* for compatibility */
  int nbitems;
  xmlChar *items[500][50];
} Td_xmldatatable_tmp, *Td_xmldatatable;

/* Base */
typedef struct Td_xmlbase_tmp
{
  xmlChar *name;
  xmlChar *comment;
  int nbtables;
  Td_xmltable tables[50];
  int nbviews;
  Td_xmlview views[50];
  int nbdatatables;
  Td_xmldatatable datatables[50];
} Td_xmlbase_tmp, *Td_xmlbase;

/*****************************************************************************/
/* Types fichier support (fichier XML sur 1-2 niveau(x) ett champs constant) */
/* copie de chez ToutDoux */
/*****************************************************************************/
/* Dfinition de l'analyse */
typedef struct Td_xmlflower_def_tmp
{
  gchar *file;
  gchar *root_name;
  gchar *branch_name;
  int branch_nbattributs;
  gchar *branch_attribut[5];
  gchar *petal_name;
  int petal_nbattributs;
  gchar *petal_attribut[5];
  gchar *foliole_name;
  int foliole_nbattributs;
  gchar *foliole_attribut[5];
} Td_xmlflower_def_tmp, *Td_xmlflower_def;

typedef struct Td_xmlflower_tmp
{
  int nbitems;
  gchar *items_level[500];
  int items_nbchilds[500];
  xmlChar *items_value[500][50];
} Td_xmlflower_tmp, *Td_xmlflower;

/*****************************************************************************/
/* Types greffons */
/* copie de chez ToutDoux */
/*****************************************************************************/
/* Identification du greffon */
typedef struct Td_about_plugins_tmp
{
  gchar *name; /* nom */
  gchar *type; /* type (preference, communication, view, help) */
  gchar *version; /* version */
  gchar *blurb; /* ligne rsum */
  gchar *authors; /* auteurs */
  gchar *help; /* rsum */
  gchar *path1; /* classement du greffon : 1 catgorie */
  gchar *path2; /* classement du greffon : 2 catgorie */
  gchar *path3; /* classement du greffon : nom */
  gchar *copyright; /* droit d'auteurs */
  gchar *license; /* licence */
  gchar *web; /* lien web */
} Td_about_plugins_tmp, *Td_about_plugins;

/*****************************************************************************/
/* Variables globales */
/*****************************************************************************/
/* Popt */
gchar *HOPLA_INTERFACE_POPT;
gchar *HOPLA_HOTE_POPT;
gchar *HOPLA_PORT_POPT;
gchar *HOPLA_USER_POPT;
gchar *HOPLA_PASSWORD_POPT;
gchar *HOPLA_BASE_POPT;
gchar *HOPLA_FILE_POPT;
gchar *HOPLA_OPERATION_POPT;
gchar *HOPLA_QUERY_POPT;
gchar *HOPLA_TABLE_POPT;
gchar *HOPLA_TEMPLATE_POPT;
gchar *HOPLA_REFRESH_METHOD_POPT;
int HOPLA_OBSO_MODE_POPT;
int HOPLA_ZIP_MODE_POPT;
int HOPLA_TEST_MODE_POPT;
int HOPLA_NOCOLOR_MODE_POPT;

/* fichier XML de log - XML log file */
gchar *HOPLA_XMLLOG_FILE_POPT;
xmlDocPtr HOPLA_XMLLOG_DOC;
xmlNsPtr HOPLA_XMLLOG_NS;
xmlNodePtr HOPLA_XMLLOG_TREE;
xmlNodePtr HOPLA_XMLLOG_ITEM;
int HOPLA_XMLLOG_LEVEL;

/* Greffons - Plug-ins */
gchar *HOPLA_PLUGINS_DIRECTORY; /* localisation du rpertoire des greffons */
gchar *HOPLA_PLUGIN_FILE; /* nom du greffon courant de l'interface de base de donnes */

/* Rafrachir - Updating */
gboolean HOPLA_NEW_NODE[50][500]; /* node  ajouter */
gboolean HOPLA_CHANGE_NODE[50][500]; /* node  modifier */
gboolean HOPLA_OBSO_NODE[50][500]; /* node  supprimer */

/*****************************************************************************/
/* Message */
/*****************************************************************************/
void hopla_message (gchar *message, gchar *type);
gboolean hopla_open_xmllog (void);
gboolean hopla_close_xmllog (void);

/*****************************************************************************/
/* Greffons */
/*****************************************************************************/
gboolean hopla_verif_plugins (gchar *file, gchar *function);

/*****************************************************************************/
/* Commandes base de donnes */
/*****************************************************************************/
Td_xmlbase hopla_parse_dbbase (void);
Td_xmlbase hopla_read_dbbase (Td_xmlbase template);
Td_xmldatatable hopla_query (char *requete);
gboolean hopla_write_dbbase (Td_xmlbase new_base);
gboolean hopla_write_dbdatatable (Td_xmlbase new_base);
gchar *hopla_strescape (const gchar *source);
int hopla_findindex_table (Td_xmlbase base, gchar *table_name);
int hopla_findindex_field (Td_xmltable table, gchar *field_name);
Td_xmldatatable hopla_admin_read (void);
gboolean hopla_admin_write (Td_xmldatatable new_datatable, Td_xmldatatable old_datatable);

/*****************************************************************************/
/* Parser Base XML */
/* copie de la libtoutdoux */
/*****************************************************************************/
Td_xmlfield td_parse_xmlfield (xmlDocPtr doc, xmlNsPtr ns, xmlNodePtr cur);
Td_xmltable td_parse_xmltable (xmlDocPtr doc, xmlNsPtr ns, xmlNodePtr cur);
Td_xmlviewfield td_parse_xmlviewfield (xmlDocPtr doc, xmlNsPtr ns, xmlNodePtr cur);
Td_xmlview td_parse_xmlview (xmlDocPtr doc, xmlNsPtr ns, xmlNodePtr cur);
Td_xmldatatable td_parse_xmldatatable (xmlDocPtr doc, xmlNsPtr ns, xmlNodePtr cur);
Td_xmlbase td_parse_xmlbase (char *file);
gboolean td_save_xmlbase (gchar *fichier, Td_xmlbase cur_base, gchar *mode);


