/*****************************************************************************/
/* structure.h : Commandes relatives  la structure de la base donnes 
 * structure.h : Data base's structure commands
 *
 *
 * Greffon hOpla : Interface PostgreSQL
 * hOpla's plug-in : PostgreSQL interface
 * Copyright (c) 2000 Philippe Roy
 * Auteur - Author : Philippe Roy <ph_roy@yahoo.com>
 *
 *
 * Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
 * sous les termes de la licence publique gnrale GNU telle qu'elle est publie par
 * la Free Software Foundation ; soit la version 2 de la licence, ou
 * (comme vous voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir qu'il sera utile,
 * mais SANS AUCUNE GARANTIE ; mme sans la garantie de
 * COMMERCIALIT ou d'ADQUATION A UN BUT PARTICULIER. Voir la
 * licence publique gnrale GNU pour plus de dtails.
 *
 * Vous devriez avoir reu une copie de la licence publique gnrale GNU
 * avec ce programme ; si ce n'est pas le cas, crivez  la Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/*****************************************************************************/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>


/*****************************************************************************/
/* Analyse base de donnes */
/*****************************************************************************/
Td_xmlfield parse_dbfield (PGconn *connexion, int field_reference, gchar *field_name, int type_reference, int type_bytes);
Td_xmltable parse_dbtable (PGconn *connexion, int table_reference, gchar *table_name);
Td_xmlbase parse_dbbase (PGconn *connexion);
Td_xmlbase plugins_parse_dbbase (void);


/*****************************************************************************/
/* Ecriture base de donnes */
/*****************************************************************************/
gboolean table_create (PGconn *connexion, Td_xmltable table);
gboolean table_remove (PGconn *connexion, Td_xmltable table);
gboolean table_rename (PGconn *connexion, Td_xmltable table);
gboolean table_write (PGconn *connexion, Td_xmlbase actuelle_base, Td_xmlbase nouvelle_base);
gboolean field_create (PGconn *connexion, Td_xmltable table, Td_xmlfield field);
gboolean field_remove (PGconn *connexion, Td_xmltable table, Td_xmlfield field, Td_xmlbase nouvelle_base);
gboolean field_rename (PGconn *connexion, Td_xmltable table, Td_xmlfield field, Td_xmlbase nouvelle_base);
gboolean field_write (PGconn *connexion, Td_xmlbase actuelle_base, Td_xmlbase nouvelle_base);
gboolean type_rename (PGconn *connexion, Td_xmltable table, Td_xmlfield field);
gboolean type_write (PGconn *connexion, Td_xmlbase actuelle_base, Td_xmlbase nouvelle_base);
gboolean plugins_write_dbbase (Td_xmlbase new_base);
